package sfs.model.domain;

import java.io.Serializable;
import java.util.Date;

/**
 * Clase que permite obtener los parametros de la tabla t5514sst_aplic
 * @author SOFT & NET SOLUTIONS
 */
public class T5514Bean implements Serializable {
	private static final long serialVersionUID = -4290535520422585611L;

	private Integer cod_st;				//Cdigo de sello de tiempo

    private Integer cod_aplic;			//Cdigo de aplicacin

    private Date fec_regis;				//Fecha de registro

    private String cod_usuregis;		//Usuario de Registro

    private Date fec_modif;				//Fecha de modificacin

    private String cod_usumodif;		//Usuario de modificacin

    /**
   	 * Obtiene el valor de cdigo de sello de tiempo
   	 * @author SOFT & NET SOLUTIONS
   	 * @return Integer cod_st cdigo de sello de tiempo
   	 */
    public Integer getCod_st() {
        return cod_st;
    }

    /**
   	 * Reemplaza el valor de cdigo de sello de tiempo
   	 * @author SOFT & NET SOLUTIONS
   	 * @param Integer cod_st cdigo de sello de tiempo
   	 */
    public void setCod_st(Integer cod_st) {
        this.cod_st = cod_st;
    }

    /**
   	 * Obtiene el valor de cdigo de aplicacin
   	 * @author SOFT & NET SOLUTIONS
   	 * @return Integer cod_aplic cdigo de aplicacin
   	 */
    public Integer getCod_aplic() {
        return cod_aplic;
    }

    /**
   	 * Reemplaza el valor de cdigo de aplicacin
   	 * @author SOFT & NET SOLUTIONS
   	 * @param Integer cod_aplic cdigo de aplicacin
   	 */
    public void setCod_aplic(Integer cod_aplic) {
        this.cod_aplic = cod_aplic;
    }

    /**
   	 * Obtiene el valor de la fecha de registro
   	 * @author SOFT & NET SOLUTIONS
   	 * @return Date fec_regis fecha de registro
   	 */
   	public Date getFec_regis() {
   		return fec_regis;
   	}

   	/**
   	 * Reemplaza el valor de la fecha de registro
   	 * @author SOFT & NET SOLUTIONS
   	 * @param Date fec_regis fecha de registro
   	 */
   	public void setFec_regis(Date fec_regis) {
   		this.fec_regis = fec_regis;
   	}

   	/**
   	 * Obtiene el valor de usuario de registro
   	 * @author SOFT & NET SOLUTIONS
   	 * @return String cod_usuregis usuario de registro
   	 */
   	public String getCod_usuregis() {
   		return cod_usuregis;
   	}

   	/**
   	 * Reemplaza el valor de usuario de registro
   	 * @author SOFT & NET SOLUTIONS
   	 * @param String cod_usuregis usuario de registro
   	 */
   	public void setCod_usuregis(String cod_usuregis) {
   		this.cod_usuregis = cod_usuregis;
   	}

   	/**
   	 * Obtiene el valor de fecha de modificacin
   	 * @author SOFT & NET SOLUTIONS
   	 * @return Date fec_modif fecha de modificacin
   	 */
   	public Date getFec_modif() {
   		return fec_modif;
   	}

   	/**
   	 * Reemplaza el valor de fecha de modificacin
   	 * @author SOFT & NET SOLUTIONS
   	 * @param Date fec_modif fecha de modificacin
   	 */
   	public void setFec_modif(Date fec_modif) {
   		this.fec_modif = fec_modif;
   	}

   	/**
   	 * Obtiene el valor del usuario de modificacin
   	 * @author SOFT & NET SOLUTIONS
   	 * @param String cod_usumodif cdigo usuario modificacin
   	 */
   	public String getCod_usumodif() {
   		return cod_usumodif;
   	}

   	/**
   	 * Reemplaza el valor del usuario de modificacin
   	 * @author SOFT & NET SOLUTIONS
   	 * @param String cod_usumodif cdigo usuario modificacin
   	 */
   	public void setCod_usumodif(String cod_usumodif) {
   		this.cod_usumodif = cod_usumodif;
   	}

}